/* Client.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 06.11.2017
 */

//  ZPAF1:    ,         : 
// Proizvod od ConcreteFactory1:  ProductA-ProductA1  ProductB-ProductB1
// Proizvod od ConcreteFactory2:  ProductA-ProductA2  ProductB-ProductB2 

//              . 
//          (...) 

package ZPAF1;

// :        .

interface AbstractFactory 
{ AbstractProductA createProductA();
  AbstractProductB createProductB();
}


/*:     . */
interface AbstractProductA  
{String getProductA();}

interface AbstractProductB 
{String getProductB();}

// :   AbstractFacory ,      .
class ConcreteFactory1 ... 
{ @Override
  public AbstractProductA createProductA(){...}
  @Override
  public AbstractProductB createProductB() {return new ProductB1();}
}

class ConcreteFactory2 ... 
{ @Override
  public AbstractProductA createProductA(){return new ProductA2();}
  @Override
  public AbstractProductB createProductB() {...}
}


/* : )    (ProductA1,ProductA2,ProductB1,ProductB2)     
                  (ConcreteFactory1  ConcreteFactory2).
           )     AbstractProductA  AbstractProductB. */
class ProductA1 implements AbstractProductA  
{@Override
 public String getProductA(){return "ProductA1";}}

class ProductA2 implements AbstractProductA   
{@Override
 public String getProductA(){return "ProductA2";}}

class ProductB1 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB1";}}

class ProductB2 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB2";}}

// :    AbstractFactory, AbstractProductA  AbstractProductB        .
class Client  // 
{
  AbstractFactory af; 
  AbstractProductA  apa; 
  ... 
  Product prod;

  Client(AbstractFactory af1){af = af1; prod = new Product();}
  public static void main(String args[])
	{  Client cl;
           ConcreteFactory1 cf1 = new ConcreteFactory1();  
           cl = new Client(...);
           System.out.println("Proizvod od ConcreteFactory1: " + cl.Create());

           ConcreteFactory2 cf2 = new ConcreteFactory2();  
           cl = new Client(...);
           System.out.println("Proizvod od ConcreteFactory2: " + cl.Create());
                     
                }

        String Create() 
    	{   apa = af.createProductA();
       	    apb = af.createProductB();
       	    prod.p  = " ProductA-" + apa.getProductA() + "  ProductB-" + apb.getProductB();
            return prod.p; 
        }
}

// :        Client   Create()l 
class Product {String p;}


