/* Director.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 06.11.2017
 */

//  ZZPBU1:    ,         : 
// Proizvod od ConcreteBuilder1:  ProductA-ProductA1  ProductB-ProductB2
// Proizvod od ConcreteBuilder2:  ProductA-ProductA1  ProductB-ProductB1 

//              . 
//          (...)

package ZPBU1;

// :    Builder        .

abstract class Builder 
{ AbstractProductA apa;
  AbstractProductB apb;
  Product prod;
  Builder(){prod = new Product();}
  abstract void createProductA();
  abstract void createProductB();
  void createProduct() { prod.p  = " ProductA-" + apa.getProductA() + "  ProductB-" + apb.getProductB();}
  String getProduct() {return prod.p;}
}


/*:     . */
interface AbstractProductA  
{String getProductA();}

interface AbstractProductB 
{String getProductB();}

// :   Builder ,      .
class ConcreteBuilder1 extends Builder 
{ @Override
  public void createProductA(){...}
  @Override
  public void createProductB() {apb = new ProductB2();}
}
  
class ConcreteBuilder2 extends Builder 
{ @Override
  public void createProductA(){apa =  new ProductA1();}
  @Override
  public void createProductB() {apb = new ProductB1();}
}


/* : )    (ProductA1,ProductA2,ProductB1,ProductB2)     
                  (ConcreteBuilder1  ConcreteBuilder2).
           )     AbstractProductA  AbstractProductB. */
class ProductA1 implements AbstractProductA  
{@Override
 public String getProductA(){...}}

class ProductA2 implements AbstractProductA   
{@Override
 public String getProductA(){return "ProductA2";}}

class ProductB1 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB1";}}

class ProductB2 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB2";}}

// :    Builder     .
class Director  // 
{
  Builder bui; 
  
  Director(Builder bui1){bui = bui1;}
  public static void main(String args[])
	{  Director di;
           ConcreteBuilder1 cbu1 = new ConcreteBuilder1();  
           di = new Director(cbu1);
           di.Construct();
           System.out.println("Proizvod od ConcreteBuilder1: " + di.bui.getProduct());

           
           ConcreteBuilder2 cbu2 = new ConcreteBuilder2();  
           di = new Director(cbu2);
           di.Construct();
           ...
                     
        }

 void Construct() 
   {   bui.createProductA();
       bui.createProductB();
       bui.createProduct();
   }
}

// :        Director   Construct()l 
class Product {String p;}


