/* Client.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 06.11.2017
 */

//  ZZPFM1:    ,         : 
// Proizvod od ConcreteCreator1:  ProductA(ProductA1)  ProductB-ProductB2
// Proizvod od ConcreteCreator2:  ProductA(ProductA2)  ProductB-ProductB1 

//              . 
//          (...)

package ZPFM1;

// :    Creator        .

abstract class Creator 
{ AbstractProductA apa;
  AbstractProductB apb;
  Product prod;
  Creator(){prod = new Product();}
  abstract void createProductA();
  abstract void createProductB();
  void createProduct() 
    { createProductA();
      createProductB();
      prod.p  = " ProductA" + apa.getProductA() + "  ProductB-" + apb.getProductB();
    }
  String getProduct() {return prod.p;}
}


/*:     . */
interface AbstractProductA  
{String getProductA();}

interface AbstractProductB 
{String getProductB();}

// :   Creator ,      .
class ConcreteCreator1 extends Creator 
{ @Override
  public void createProductA(){apa = new ProductA1();}
  @Override
  public void createProductB() {apb = new ProductB2();}
}
  
class ConcreteCreator2 extends Creator 
{ @Override
  public void createProductA(){apa =  new ProductA2();}
  @Override
  public void createProductB() {apb = new ProductB1();}
}


/* : )    (ProductA1,ProductA2,ProductB1,ProductB2)     
                  (ConcreteCreator1  ConcreteCreator2).
           )     AbstractProductA  AbstractProductB. */
class ProductA1 implements AbstractProductA  
{@Override
 public String getProductA(){return ...;}}

class ProductA2 implements AbstractProductA   
{@Override
 public String getProductA(){return "(ProductA2)";}}

class ProductB1 implements AbstractProductB 
{@Override
 public String getProductB(){...}}

class ProductB2 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB2";}}

// :    Creator   Creator .
class Client   
{
  Creator bui; 
  
  Client(Creator bui1){bui = bui1;}
  public static void main(String args[])
	{  Client di;
           ConcreteCreator1 cbu1 = new ConcreteCreator1();  
           di = new Client(cbu1);
           di.Construct();
           System.out.println("Proizvod od ConcreteCreator1: " + cbu1.getProduct());

           
           ConcreteCreator2 cbu2 = new ConcreteCreator2();  
           di = new Client(cbu2);
           di.Construct();
           System.out.println("Proizvod od ConcreteCreator2: " + cbu2.getProduct());
                     
        }

 void Construct() 
   {   ...
   }
}

/*:    Product    */
interface IProduct {String getProduct();} 

// :   Product    . 
class Product implements IProduct
 {String p;
  public String getProduct(){return p;}
}


