/* Director.java
 * @autor  prof. dr Sinisa Vlajic,
 * Univerzitet u Beogradu
 * Fakultet organizacionih nauka 
 * Katedra za softversko inzenjerstvo
 * Laboratorija za softversko inzenjerstvo
 * 06.11.2017
 */

//  ZPPR1:    ,         : 
// Proizvod od ConcreteBuilder1:  ProductA-ProductA1  ProductB-ProductB2
// Proizvod - klon od ConcreteBuilder1:  ProductA-ProductA1  ProductB-ProductB2
// Proizvod od ConcreteBuilder2:  ProductA-ProductA2  ProductB-ProductB1
// Proizvod - klon od ConcreteBuilder2:  ProductA-ProductA2  ProductB-ProductB1 

//              . 
//          (...)

package ZPPR1;

// :    Builder        .

abstract class Builder 
{ AbstractProductA apa;
  AbstractProductB apb;
  Product prod;
  Builder(){prod = new Product();}
  abstract void createProductA();
  abstract void createProductB();
  abstract public Builder Clone();
  void createProduct() { prod.p  = " ProductA-" + apa.getProductA() + "  ProductB-" + apb.getProductB();}
  String getProduct() {return prod.p;}
}


/*:     . */
interface AbstractProductA  
{String getProductA();}

interface AbstractProductB 
{String getProductB();}

// :   Builder ,      .
class ConcreteBuilder1 ... Builder 
{ ConcreteBuilder1(){super();} 
  ConcreteBuilder1(Builder bu1)
    {super();
     prod.p = bu1.prod.p; 
    }  
  @Override
  public void createProductA(){apa = new ProductA1();}
  @Override
  public void createProductB() {apb = new ProductB2();}
@Override
  public Builder Clone(){return new ConcreteBuilder1(this);}
}
  
class ConcreteBuilder2 ... Builder 
{ ConcreteBuilder2(){super();}
  ConcreteBuilder2(Builder bu1){super();prod.p = bu1.prod.p; }    
  @Override
  public void createProductA(){apa =  new ProductA2();}
  @Override
  public void createProductB() {apb = new ProductB1();}
@Override
  public Builder Clone(){...}
}


/* : )    (ProductA1,ProductA2,ProductB1,ProductB2)     
                  (ConcreteBuilder1  ConcreteBuilder2).
           )     AbstractProductA  AbstractProductB. */
class ProductA1 implements AbstractProductA  
{@Override
 public String getProductA(){return "ProductA1";}}

class ProductA2 implements AbstractProductA   
{@Override
 public String getProductA(){return "ProductA2";}}

class ProductB1 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB1";}}

class ProductB2 implements AbstractProductB 
{@Override
 public String getProductB(){return "ProductB2";}}

// :    Builder     .
class Director  // 
{
  Builder bui; 
  
  Director(Builder bui1){bui = bui1;}
  public static void main(String args[])
	{  Director di;
           ConcreteBuilder1 cbu1 = new ConcreteBuilder1();  
           di = new Director(cbu1);
           di.Construct();
           System.out.println("Proizvod od ConcreteBuilder1: " + cbu1.getProduct());
           Builder cbu11 = cbu1.Clone();
           System.out.println("Proizvod - klon od ConcreteBuilder1: " + cbu11.getProduct());
           
           ConcreteBuilder2 cbu2 = new ConcreteBuilder2();  
           di = new Director(cbu2);
           di.Construct();
           System.out.println("Proizvod od ConcreteBuilder2: " + cbu2.getProduct());
           Builder cbu21 = cbu2.Clone(); 
           ...
        }

 void Construct() 
   {   bui.createProductA();
       bui.createProductB();
       bui.createProduct();
   }
}

// :        Director   Construct()l 
class Product {String p;}


